<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `/home/keir/.cargo/registry/src/github.com-1ecc6299db9ec823/getrandom-0.1.15/src/error.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>error.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css"><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script src="../../storage.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="shortcut icon" href="https://www.rust-lang.org/favicon.ico"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../getrandom/index.html'><div class='logo-container'><img src='https://www.rust-lang.org/logos/rust-logo-128x128-blk.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../settings.html"><img src="../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="comment">// Copyright 2018 Developers of the Rand project.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>
<span class="kw">use</span> <span class="ident">core</span>::<span class="ident">fmt</span>;
<span class="kw">use</span> <span class="ident">core</span>::<span class="ident">num</span>::<span class="ident">NonZeroU32</span>;

<span class="doccomment">/// A small and `no_std` compatible error type.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The [`Error::raw_os_error()`] will indicate if the error is from the OS, and</span>
<span class="doccomment">/// if so, which error code the OS gave the application. If such an error is</span>
<span class="doccomment">/// encountered, please consult with your system documentation.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Internally this type is a NonZeroU32, with certain values reserved for</span>
<span class="doccomment">/// certain purposes, see [`Error::INTERNAL_START`] and [`Error::CUSTOM_START`].</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">Eq</span>, <span class="ident">PartialEq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Error</span>(<span class="ident">NonZeroU32</span>);

<span class="kw">impl</span> <span class="ident">Error</span> {
    <span class="attribute">#[<span class="ident">deprecated</span>(<span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;0.1.7&quot;</span>)]</span>
    <span class="doccomment">/// Unknown error.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">UNKNOWN</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="ident">UNSUPPORTED</span>;
    <span class="attribute">#[<span class="ident">deprecated</span>(<span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;0.1.7&quot;</span>)]</span>
    <span class="doccomment">/// System entropy source is unavailable.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">UNAVAILABLE</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="ident">UNSUPPORTED</span>;

    <span class="doccomment">/// Codes below this point represent OS Errors (i.e. positive i32 values).</span>
    <span class="doccomment">/// Codes at or above this point, but below [`Error::CUSTOM_START`] are</span>
    <span class="doccomment">/// reserved for use by the `rand` and `getrandom` crates.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">INTERNAL_START</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">31</span>;

    <span class="doccomment">/// Codes at or above this point can be used by users to define their own</span>
    <span class="doccomment">/// custom errors.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">CUSTOM_START</span>: <span class="ident">u32</span> <span class="op">=</span> (<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">31</span>) <span class="op">+</span> (<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">30</span>);

    <span class="doccomment">/// Extract the raw OS error code (if this error came from the OS)</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This method is identical to `std::io::Error::raw_os_error()`, except</span>
    <span class="doccomment">/// that it works in `no_std` contexts. If this method returns `None`, the</span>
    <span class="doccomment">/// error value can still be formatted via the `Display` implementation.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">raw_os_error</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">i32</span><span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">get</span>() <span class="op">&lt;</span> <span class="self">Self</span>::<span class="ident">INTERNAL_START</span> {
            <span class="prelude-val">Some</span>(<span class="self">self</span>.<span class="number">0</span>.<span class="ident">get</span>() <span class="kw">as</span> <span class="ident">i32</span>)
        } <span class="kw">else</span> {
            <span class="prelude-val">None</span>
        }
    }

    <span class="doccomment">/// Extract the bare error code.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This code can either come from the underlying OS, or be a custom error.</span>
    <span class="doccomment">/// Use [`Error::raw_os_error()`] to disambiguate.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">code</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">NonZeroU32</span> {
        <span class="self">self</span>.<span class="number">0</span>
    }
}

<span class="macro">cfg_if</span><span class="macro">!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">unix</span>)]</span> {
        <span class="kw">fn</span> <span class="ident">os_err</span>(<span class="ident">errno</span>: <span class="ident">i32</span>, <span class="ident">buf</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">str</span><span class="op">&gt;</span> {
            <span class="kw">let</span> <span class="ident">buf_ptr</span> <span class="op">=</span> <span class="ident">buf</span>.<span class="ident">as_mut_ptr</span>() <span class="kw">as</span> <span class="kw-2">*</span><span class="kw-2">mut</span> <span class="ident">libc</span>::<span class="ident">c_char</span>;
            <span class="kw">if</span> <span class="kw">unsafe</span> { <span class="ident">libc</span>::<span class="ident">strerror_r</span>(<span class="ident">errno</span>, <span class="ident">buf_ptr</span>, <span class="ident">buf</span>.<span class="ident">len</span>()) } <span class="op">!</span><span class="op">=</span> <span class="number">0</span> {
                <span class="kw">return</span> <span class="prelude-val">None</span>;
            }

            <span class="comment">// Take up to trailing null byte</span>
            <span class="kw">let</span> <span class="ident">n</span> <span class="op">=</span> <span class="ident">buf</span>.<span class="ident">len</span>();
            <span class="kw">let</span> <span class="ident">idx</span> <span class="op">=</span> <span class="ident">buf</span>.<span class="ident">iter</span>().<span class="ident">position</span>(<span class="op">|</span><span class="kw-2">&amp;</span><span class="ident">b</span><span class="op">|</span> <span class="ident">b</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span>).<span class="ident">unwrap_or</span>(<span class="ident">n</span>);
            <span class="ident">core</span>::<span class="ident">str</span>::<span class="ident">from_utf8</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>[..<span class="ident">idx</span>]).<span class="ident">ok</span>()
        }
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;wasi&quot;</span>)]</span> {
        <span class="kw">fn</span> <span class="ident">os_err</span>(<span class="ident">errno</span>: <span class="ident">i32</span>, <span class="ident">_buf</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">wasi</span>::<span class="ident">Error</span><span class="op">&gt;</span> {
            <span class="ident">wasi</span>::<span class="ident">Error</span>::<span class="ident">from_raw_error</span>(<span class="ident">errno</span> <span class="kw">as</span> <span class="kw">_</span>)
        }
    } <span class="kw">else</span> {
        <span class="kw">fn</span> <span class="ident">os_err</span>(<span class="ident">_errno</span>: <span class="ident">i32</span>, <span class="ident">_buf</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">str</span><span class="op">&gt;</span> {
            <span class="prelude-val">None</span>
        }
    }
}

<span class="kw">impl</span> <span class="ident">fmt</span>::<span class="ident">Debug</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt</span>::<span class="ident">Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt</span>::<span class="prelude-ty">Result</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">dbg</span> <span class="op">=</span> <span class="ident">f</span>.<span class="ident">debug_struct</span>(<span class="string">&quot;Error&quot;</span>);
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">errno</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">raw_os_error</span>() {
            <span class="ident">dbg</span>.<span class="ident">field</span>(<span class="string">&quot;os_error&quot;</span>, <span class="kw-2">&amp;</span><span class="ident">errno</span>);
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">buf</span> <span class="op">=</span> [<span class="number">0u8</span>; <span class="number">128</span>];
            <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">err</span>) <span class="op">=</span> <span class="ident">os_err</span>(<span class="ident">errno</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">buf</span>) {
                <span class="ident">dbg</span>.<span class="ident">field</span>(<span class="string">&quot;description&quot;</span>, <span class="kw-2">&amp;</span><span class="ident">err</span>);
            }
        } <span class="kw">else</span> <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">desc</span>) <span class="op">=</span> <span class="ident">internal_desc</span>(<span class="kw-2">*</span><span class="self">self</span>) {
            <span class="ident">dbg</span>.<span class="ident">field</span>(<span class="string">&quot;internal_code&quot;</span>, <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="number">0</span>.<span class="ident">get</span>());
            <span class="ident">dbg</span>.<span class="ident">field</span>(<span class="string">&quot;description&quot;</span>, <span class="kw-2">&amp;</span><span class="ident">desc</span>);
        } <span class="kw">else</span> {
            <span class="ident">dbg</span>.<span class="ident">field</span>(<span class="string">&quot;unknown_code&quot;</span>, <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="number">0</span>.<span class="ident">get</span>());
        }
        <span class="ident">dbg</span>.<span class="ident">finish</span>()
    }
}

<span class="kw">impl</span> <span class="ident">fmt</span>::<span class="ident">Display</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt</span>::<span class="ident">Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt</span>::<span class="prelude-ty">Result</span> {
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">errno</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">raw_os_error</span>() {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">buf</span> <span class="op">=</span> [<span class="number">0u8</span>; <span class="number">128</span>];
            <span class="kw">match</span> <span class="ident">os_err</span>(<span class="ident">errno</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">buf</span>) {
                <span class="prelude-val">Some</span>(<span class="ident">err</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">err</span>.<span class="ident">fmt</span>(<span class="ident">f</span>),
                <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="macro">write</span><span class="macro">!</span>(<span class="ident">f</span>, <span class="string">&quot;OS Error: {}&quot;</span>, <span class="ident">errno</span>),
            }
        } <span class="kw">else</span> <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">desc</span>) <span class="op">=</span> <span class="ident">internal_desc</span>(<span class="kw-2">*</span><span class="self">self</span>) {
            <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="ident">desc</span>)
        } <span class="kw">else</span> {
            <span class="macro">write</span><span class="macro">!</span>(<span class="ident">f</span>, <span class="string">&quot;Unknown Error: {}&quot;</span>, <span class="self">self</span>.<span class="number">0</span>.<span class="ident">get</span>())
        }
    }
}

<span class="kw">impl</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">NonZeroU32</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">code</span>: <span class="ident">NonZeroU32</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="self">Self</span>(<span class="ident">code</span>)
    }
}

<span class="comment">// TODO: Convert to a function when min_version &gt;= 1.33</span>
<span class="macro">macro_rules</span><span class="macro">!</span> <span class="ident">internal_error</span> {
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>:<span class="ident">expr</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="ident">Error</span>(<span class="kw">unsafe</span> { <span class="ident">NonZeroU32</span>::<span class="ident">new_unchecked</span>(<span class="ident">Error</span>::<span class="ident">INTERNAL_START</span> <span class="op">+</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span> <span class="kw">as</span> <span class="ident">u16</span> <span class="kw">as</span> <span class="ident">u32</span>) })
    };
}

<span class="doccomment">/// Internal Error constants</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">UNSUPPORTED</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="macro">internal_error</span><span class="macro">!</span>(<span class="number">0</span>);
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">ERRNO_NOT_POSITIVE</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="macro">internal_error</span><span class="macro">!</span>(<span class="number">1</span>);
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">UNKNOWN_IO_ERROR</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="macro">internal_error</span><span class="macro">!</span>(<span class="number">2</span>);
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">SEC_RANDOM_FAILED</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="macro">internal_error</span><span class="macro">!</span>(<span class="number">3</span>);
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">RTL_GEN_RANDOM_FAILED</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="macro">internal_error</span><span class="macro">!</span>(<span class="number">4</span>);
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">FAILED_RDRAND</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="macro">internal_error</span><span class="macro">!</span>(<span class="number">5</span>);
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">NO_RDRAND</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="macro">internal_error</span><span class="macro">!</span>(<span class="number">6</span>);
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">BINDGEN_CRYPTO_UNDEF</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="macro">internal_error</span><span class="macro">!</span>(<span class="number">7</span>);
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">BINDGEN_GRV_UNDEF</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="macro">internal_error</span><span class="macro">!</span>(<span class="number">8</span>);
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">STDWEB_NO_RNG</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="macro">internal_error</span><span class="macro">!</span>(<span class="number">9</span>);
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">STDWEB_RNG_FAILED</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="macro">internal_error</span><span class="macro">!</span>(<span class="number">10</span>);
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">RAND_SECURE_FATAL</span>: <span class="ident">Error</span> <span class="op">=</span> <span class="macro">internal_error</span><span class="macro">!</span>(<span class="number">11</span>);

<span class="kw">fn</span> <span class="ident">internal_desc</span>(<span class="ident">error</span>: <span class="ident">Error</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span><span class="op">&gt;</span> {
    <span class="kw">match</span> <span class="ident">error</span> {
        <span class="ident">UNSUPPORTED</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="string">&quot;getrandom: this target is not supported&quot;</span>),
        <span class="ident">ERRNO_NOT_POSITIVE</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="string">&quot;errno: did not return a positive value&quot;</span>),
        <span class="ident">UNKNOWN_IO_ERROR</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="string">&quot;Unknown std::io::Error&quot;</span>),
        <span class="ident">SEC_RANDOM_FAILED</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="string">&quot;SecRandomCopyBytes: call failed&quot;</span>),
        <span class="ident">RTL_GEN_RANDOM_FAILED</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="string">&quot;RtlGenRandom: call failed&quot;</span>),
        <span class="ident">FAILED_RDRAND</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="string">&quot;RDRAND: failed multiple times: CPU issue likely&quot;</span>),
        <span class="ident">NO_RDRAND</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="string">&quot;RDRAND: instruction not supported&quot;</span>),
        <span class="ident">BINDGEN_CRYPTO_UNDEF</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="string">&quot;wasm-bindgen: self.crypto is undefined&quot;</span>),
        <span class="ident">BINDGEN_GRV_UNDEF</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="string">&quot;wasm-bindgen: crypto.getRandomValues is undefined&quot;</span>),
        <span class="ident">STDWEB_NO_RNG</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="string">&quot;stdweb: no randomness source available&quot;</span>),
        <span class="ident">STDWEB_RNG_FAILED</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="string">&quot;stdweb: failed to get randomness&quot;</span>),
        <span class="ident">RAND_SECURE_FATAL</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="string">&quot;randSecure: random number generator module is not initialized&quot;</span>),
        <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="ident">Error</span>;
    <span class="kw">use</span> <span class="ident">core</span>::<span class="ident">mem</span>::<span class="ident">size_of</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_size</span>() {
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">size_of</span>::<span class="op">&lt;</span><span class="ident">Error</span><span class="op">&gt;</span>(), <span class="number">4</span>);
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">size_of</span>::<span class="op">&lt;</span><span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">Error</span><span class="op">&gt;</span><span class="op">&gt;</span>(), <span class="number">4</span>);
    }
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../";window.currentCrate = "getrandom";</script><script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script><script defer src="../../search-index.js"></script></body></html>